package api_type

import (
	"github.com/juju/errors"

	"git.home.m-and-m.ovh/mderasse/gouick/helpers/api_type/gin_gonic"
	"git.home.m-and-m.ovh/mderasse/gouick/helpers/api_type/go_swagger"
	"git.home.m-and-m.ovh/mderasse/gouick/helpers/api_type/mojolicious"
)

func GetApiType(in ApiTypeName) (ApiTypeInterface, error) {
	if in == "" {
		return nil, errors.BadRequestf("missing parameter")
	}

	if !in.IsValid() {
		return nil, errors.NotValidf("invalid parameter")
	}

	switch in {
	case ApyTypeName_GIN_GONIC:
		return gin_gonic.ApiType{}, nil
	case ApyTypeName_GO_SWAGGER:
		return go_swagger.ApiType{}, nil
	case ApyTypeName_MOJOLICIOUS:
		return mojolicious.ApiType{}, nil
	}

	return nil, errors.NotFoundf("Unknown Api Type")
}
